#!/usr/bin/env ruby
#
# $Id: nadoka.rb,v 1.15 2004/04/22 02:32:54 ko1 Exp $
# Create : K.S. 03/07/10 20:29:07
#
# Nadoka: Irc Client Server Program
# 

require 'resolv-replace'
require 'optparse'
require 'ndk_manager'
$stdout.sync=true
$NDK_Debug  = false

module Nadoka
  NDK_Version  = '0.3.2'
  NDK_Created  = Time.now

  def self.version
    "Nadoka Ver.#{NDK_Version} with Ruby #{RUBY_VERSION} (#{RUBY_RELEASE_DATE}) [#{RUBY_PLATFORM}]"
  end
end

rcfile = nil

optparse = OptionParser.new{|opts|
  opts.banner = "Usage: ruby #{$0} [options]"

  opts.separator ""
  opts.separator "Require options:"

  opts.on("-r", "--rc [RCFILE]",
          "Specify rcfile(required)"){|f|
    rcfile = f
  }

  opts.separator ""
  opts.separator "Optional:"

  opts.on("-d", "--debug",
          "Debug Nadoka"){
    $NDK_Debug = true
    $DEBUG = true
    
    puts 'Enter Nadoka Debug mode'
  }

  opts.separator ""
  opts.separator "Common options:"

  opts.on_tail("-h", "--help", "Show this message"){
    puts Nadoka.version
    puts opts
    exit
  }
  opts.on_tail("-v", "--version", "Show version"){
    puts Nadoka.version
  }
}
optparse.parse!(ARGV)

unless rcfile
  puts Nadoka.version
  puts optparse
  exit
end

begin
  Nadoka::NDK_Manager.new(rcfile).start
rescue Nadoka::NDK_RestartProgram
  retry
end

