#
# $Id: ndk_state.rb,v 1.3 2004/04/21 22:02:37 ko1 Exp $
# Create : K.S. 04/04/20 10:42:27
#

module Nadoka
  class NDK_State
    def initialize manager
      @manager = manager
      @config  = nil
      
      @current_nick     = nil
      @current_channels = {} #Hash.new{|h,k| h[k] = []}
      # {'ch' => ['user1', 'user2', ...], ...}
      @current_mode     = {} #Hash.new{|h,k| h[k] = ''}
      # {'ch' => 'mode', ...}

      @backlog = []
    end
    attr_reader :backlog
    
    def config=(c)
      @config = c
    end
    
    def nick=(n)
      @current_nick=n
    end
    
    def nick
      @current_nick
    end

    def nick_succ
      if /^(.+)(\d)$/ =~ @current_nick
        @current_nick = $1 + ($2.to_i + 1).to_s
      else
        @current_nick += '0'
      end
      @current_nick
    end
    
    def channels
      @current_channels.keys
    end

    def channel_users ch
      if @current_channels.has_key? ch
        @current_channels[ch]
      else
        []
      end
    end

    #
    def backlog_push msg
      if @config.backlog_lines == 0
        if @manager.client_num == 0
          @backlog << msg
        end
      else
        @backlog << msg
        while @backlog.size > @config.backlog_lines
          @backlog.shift
        end
      end
    end

    def backlog_clear
      @backlog = []
    end
    
    #
    def on_join user, ch
      msg = "+ #{user} to #{ch}"
      if user == nick
        @config.clog ch, msg
        @current_channels[ch] = []
        @current_mode[ch]     = ''
      else
        if @current_channels.has_key? ch
          @config.clog ch, msg
          @current_channels[ch] << user
        end
      end
      @config.log msg
    end
    
    def on_part user, ch
      msg = "- #{user} from #{ch}"
      if user == nick
        @config.clog ch, msg
        @current_channels.delete ch
        @current_mode.delete ch
      else
        if @current_channels.has_key? ch
          @config.clog ch, msg
          @current_channels[ch].delete user
        end
      end
      @config.log msg
    end
    
    def on_nick user, newnick
      msg = "#{user} -> #{newnick}"
      if user == nick
        @current_nick = newnick
      end
      @current_channels.each{|ch, users|
        users.map!{|e|
          if e == user
            @config.clog ch, msg
            newnick
          else
            e
          end
        }
      }
      @config.log msg
    end
    
    def on_quit user, qmsg
      if user == nick
        @current_channels = {} # clear
        @current_mode     = {}
      else
        @current_channels.each{|ch, users|
          if users.include? user
            @config.clog ch, "- #{user} from #{ch}(#{qmsg})"
            users.delete(user)
          end
        }
      end
      @config.log "- #{user}(#{qmsg})"
    end
    
    def on_mode user, ch, mode, *args
      while args.size > 0
        mod = args.shift
        dst = args.shift

        if dst == nick
          if @current_mode.has_key? ch
            
          end
        end
      end
    end
    
    # RPL_NAMREPLY
    # ex) :lalune 353 test_ndk = #nadoka :test_ndk ko1_nmdk
    # 
    def on_353 ch, users
      if @current_channels.has_key? ch
        @current_channels[ch] = users.split(/ /).map{|e|
          /^@?(.+)/ =~ e
          $1
        }
      end
    end
    
  end
end

